/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_echo_thread_pool;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class ClientThread implements Runnable
{
    private Socket connection;
    private InputStream input;
    private OutputStream output;
    
    public ClientThread(Socket connection) throws IOException
    {
        this.connection=connection;
        input=connection.getInputStream();
        output=connection.getOutputStream();
    }
    
    @Override
    public void run() 
    {
        int n;
        byte[] buffer=new byte[1024];
        String answer="";
        
        try 
        {
            while((n=input.read(buffer))!=-1)
            {
                if (n>0)
                {
                    output.write(buffer,0,n);
                    output.flush();
                }
            }
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore di comunicazione");
        }
        
        try 
        {
            connection.shutdownInput();
            connection.shutdownOutput();
            connection.close();
            System.out.println("Connnessione chiusa");
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore durante la chiusura della connessione");
        }
    }  
}
