/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._protocollo_ciao_lao;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.util.Scanner;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPServer implements Runnable
{
    private DatagramSocket socket;
    
    public UDPServer(int port) throws SocketException
    {
        socket=new DatagramSocket(port);
        socket.setSoTimeout(1000);
    }
    
    public void run()
    {
        byte[] buffer=new  byte[8192];
        byte[] responseBuffer=new  byte[8192];
        DatagramPacket request=new DatagramPacket(buffer, buffer.length);
        String stringMessage;
        
        while(!Thread.interrupted())
        {
            try 
            {
               //String parolaChiave=new String("ciao".getBytes("UTF-8"),"UTF-8");
               // byte[] parolaChiave="ciao".getBytes("UTF-8");
                String parolachiave="ciao";
                socket.receive(request);
                DatagramPacket answer=new DatagramPacket(request.getData(), request.getLength(),request.getAddress(),request.getPort());
                stringMessage=new String(answer.getData(),"UTF-8");
                stringMessage=stringMessage.substring(0, request.getLength()); //altrimenti la stringa è lunga 8192 caratteri
               // stringMessage=stringMessage.substring(0, 4);
               // int l2=parolaChiave.length();
               
                //if (stringMessage.length()==parolachiave.length() && stringMessage.substring(0,parolachiave.length()).equals(parolachiave))
                if (stringMessage.equals(parolachiave))
                {
                    
                    responseBuffer="lao".getBytes("UTF-8");
                    answer=new DatagramPacket(responseBuffer, "lao".length(), request.getAddress(), request.getPort());
                }
                else
                    answer=new DatagramPacket(buffer, buffer.length, request.getAddress(), request.getPort());

                socket.send(answer);
                System.out.println("--> risposta inviata");
            }
            catch (SocketTimeoutException ex) 
            {
                    System.out.println("Timeout");
            }
            catch (IOException ex) 
            {
                System.out.println("Errore di comunicazione");
            }
        }
    }
    
    public static void main(String[] args) 
    {
        Scanner tastiera=new Scanner(System.in);
        try 
        {
            UDPServer echoServer=new UDPServer(7);
            Thread threadServer=new Thread(echoServer);
            threadServer.start();
            tastiera.nextLine();
            threadServer.interrupt();
            threadServer.join();
            System.out.println("Server interrotto");
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile creare il socket");
        } 
        catch (InterruptedException ex)
        {
            Logger.getLogger(UDPServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
