/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_datetime;

import java.io.IOException;
import java.io.InputStream;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class TCPClient 
{
    private Socket clientSocket;
    
    public TCPClient() throws SocketException
    {
        clientSocket=new Socket();
        clientSocket.setSoTimeout(1000);
    }
    
    public String getDateTime(String serverAddressString, int port) throws IOException
    {
        byte[] bufferResponse=new byte[1024];
        InputStream inputStream;
        int n;
        String frag;
        String responseMessage="";
        InetSocketAddress serverAddress=new InetSocketAddress(serverAddressString, port);
       
        clientSocket.connect(serverAddress,1000);
        
        inputStream=clientSocket.getInputStream();
        
        while ((n=inputStream.read(bufferResponse))!=-1)
        {
            frag=new String(bufferResponse,0,n,"UTF-8");
            responseMessage+=frag;
        }
        inputStream.close();
        clientSocket.close();
        return responseMessage; 
    }
    
    public static void main(String[] args) 
    {
        String ipServer="127.0.0.1";
        int serverPort=13;
        String responseMessage;
        
        try 
        {
            TCPClient client=new TCPClient();
            responseMessage=client.getDateTime(ipServer, serverPort);
            System.out.println("Risposta del server --> "+responseMessage);
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket nel client");
        } 
        catch (SocketTimeoutException ex) 
        {
            System.out.println("Errore di comunicazione");
        }
        catch (IOException ex) 
        {
            System.out.println("Errore di comunicazione");
        }   
    }
}
