/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._tcp_concorrente_echo;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.SocketException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class ClientThread implements Runnable
{
    private Socket connection;
    private OutputStream output;
    private InputStream input;
    
    public ClientThread(Socket connection) throws SocketException, IOException
    {
        this.connection=connection;
        //this.connection.setSoTimeout(1000);
        input=this.connection.getInputStream();
        output=this.connection.getOutputStream();
    }
    
    public void run()
    {
        int n;
        byte[] bufferInput=new byte[1024];
       // String responseMessage="";
       // String frag;
        
        try 
        {
            while((n=input.read(bufferInput))!=-1)
            {
//                frag=new String(bufferInput,0,n,"UTF-8");
//                responseMessage+=frag;
                if (n>0)
                {
                    output.write(bufferInput,0,n);
                    output.flush();
                }
                
            }
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore di comunicazione");
        }
        
        try 
        {
            connection.shutdownInput();
            connection.shutdownOutput();
            connection.close();
        } 
        catch (IOException ex) 
        {
            System.out.println("Errore nella chiusura della connessione con "+connection.getInetAddress().toString()+"/"+connection.getPort());
        }     
    }
}
