/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._udp_chat_a_due;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPClientReceiver implements Runnable
{
    private DatagramSocket socket;
    private final int MAX_BYTE_RESPONSE=1024;
    
    public UDPClientReceiver(DatagramSocket socket) throws SocketException
    {
        this.socket=socket;
    //    socket.setSoTimeout(1000);
    }
    
    public void run()
    {
       // byte[] requestBuffer=message.getBytes("UTF-8");
       // InetAddress serverAddress=InetAddress.getByName(ipServerAddress);
        byte[] responseBuffer=new byte[MAX_BYTE_RESPONSE];
        DatagramPacket response=new DatagramPacket(responseBuffer, responseBuffer.length);
        String responseMessage;

       while(!Thread.interrupted())
       {
            try 
            {   
                socket.receive(response);
                responseMessage=new String(response.getData(),"UTF-8");
                responseMessage=responseMessage.substring(0, response.getLength());
                System.out.println(responseMessage);
            } 
             catch (SocketTimeoutException ex) 
            {
                        
            } 
            catch (IOException ex) 
            {
                //System.out.println("Errore di comunicazione");            
            } 
       }

    }
    
     
    
    /* 
   
    public static void main(String[] args) 
    {
        String requestMessage="ADD;Luciano";
        String ipServer="127.0.0.1";
        int serverPort=1212;
        String responseMessage; 
        
        try 
        {
            UDPClientReceiver clientChat=new UDPClientReceiver();
            
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket");
        }    
               try
            {
            UDPClientReceiver clientChat=new UDPClientReceiver();
            
            responseMessage=clientChat.sendAndReceive(requestMessage, ipServer, serverPort);
            //responseMessage=responseMessage.substring(0, responseMessage.length());
            System.out.println("Risposta del server --> "+responseMessage);
            clientChat.close();
            }
            catch (SocketException ex)
            {
            System.out.println("Impossibile aprire il socket");
            }
            catch (UnknownHostException ex)
            {
            System.out.println("Host sconosciuto");
            }
            
            catch (IOException ex)
            {
            System.out.println("Errore di comunicazione");        
            }
            
       
    }
*/
   
}
