/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._udp_chat_a_due;

import java.net.DatagramSocket;
import java.net.SocketException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 * digitare "quit" per chiudere il client
 */
public class UDPChatClient 
{
    public static void main(String[] args) 
    {
        
       // String requestMessage="ADD;Luciano";
        String ipServer="127.0.0.1";
        int serverPort=1212;
        String message;
        DatagramSocket socket;
        
        Scanner tastiera=new Scanner(System.in);
        try 
        {
           socket = new DatagramSocket();
            UDPClientReceiver clientReciver=new UDPClientReceiver(socket);
            Thread receiver =new Thread(clientReciver);
            receiver.start();
            do
            {
                message=tastiera.nextLine();
                if (message.equals("quit"))
                {
                    receiver.interrupt();
                    socket.close();
                    System.out.println("Client disconnesso");
                }
                else
                {
                    UDPClientSender clientSender=new UDPClientSender(socket, message, ipServer,serverPort);
                    Thread sender=new Thread(clientSender);
                    sender.start();
                }
            }while(!message.equals("quit"));
            
            
        } 
        catch (SocketException ex) 
        {
            System.out.println("Impossibile aprire il socket");
        }
        
        
    }
}
