/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.mycompany._udp_chat_a_due;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author gian
 */
public class UDPClientSender implements Runnable
{
    private DatagramSocket socket;
    private String message;
    private String ipServer;
    private int port;
    
    public UDPClientSender(DatagramSocket socket, String message, String ipServer, int port)
    {
        this.socket=socket;
        this.message=message;
        this.ipServer=ipServer;
        this.port=port;
    }
    @Override
    public void run() 
    {
        try 
        {   
            byte[] requestBuffer=message.getBytes("UTF-8");
            DatagramPacket request=new DatagramPacket(requestBuffer,requestBuffer.length,InetAddress.getByName(ipServer),port);
            socket.send(request);
        } 
        catch (UnknownHostException ex) 
        { 
            System.out.println("Server non noto");
        }
        catch (IOException ex) 
        {
            System.out.println("Errore di comunicazione");
        }
    }

}
